<template>
  <v-form
    v-model="valid"
    @submit.prevent="userLogin"
    ref="form"
    lazy-validation
  >
    <v-container fluid>
      <v-row>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="login.username"
            label="Username"
            outlined
            type="'email'"
            :rules="rules.username"
            placeholder="Please input user name"
            clearable
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="login.password"
            label="Password"
            :type="showPassword ? 'text' : 'password'"
            outlined
            clearable
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <v-btn type="'submit'" color="primary"
            ><v-icon>mdi-login</v-icon>Login</v-btn
          >
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script lang="ts">
import { HTTPResponse } from '@nuxtjs/auth-next'
import Vue from 'vue'
import Vuetify from 'vuetify'
export default Vue.extend({
  layout: 'plain',
  data() {
    return {
      valid: false,
      showPassword: false,
      login: {
        username: '',
        password: '',
      },
      rules: {
        username: [
          (v: string) => !!v || 'user name is required',
          (v: string) => v.indexOf('@') !== 0 || 'Should be email.',
        ],
      },
    }
  },
  methods: {
    async userLogin() {
      try {
        if (this.valid) {
          let response = await this.$auth.loginWith('local', {
            data: this.login,
          })
          if (response) this.$apolloHelpers.onLogin(response.data.token)
        }
      } catch (err) {
        console.log(err)
      }
    },
  },
})
</script>